#include "orxonox_gui_exec.h"
GtkWidget *exec_flags_label;
struct settings *exec_orxonox_settings;
GtkWidget *orxonox_gui_exec_frame (struct settings *orxonox_settings)
{
  GtkWidget *frame;
  GtkWidget *save_settings_button;
  GtkWidget *show_menu_button;
  GtkWidget *start_button;
  GtkWidget *quit_button;
  GtkWidget *flags_frame;


  frame = gtk_frame_new ( "Execute-Tags:");
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);
  {
    GtkWidget *orxonox_gui_exec_vbox;
    orxonox_gui_exec_vbox = gtk_vbox_new (FALSE, 5);
    {

	start_button = gtk_button_new_with_label ("Start");
	gtk_box_pack_start(GTK_BOX (orxonox_gui_exec_vbox), start_button, TRUE, TRUE, 5);

	save_settings_button = gtk_check_button_new_with_label ("Save Settings");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (save_settings_button), orxonox_settings->exec_save_settings);
	gtk_box_pack_start(GTK_BOX (orxonox_gui_exec_vbox), save_settings_button, TRUE, TRUE, 0);

	show_menu_button = gtk_check_button_new_with_label ("Always show this Menu");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (show_menu_button), orxonox_settings->exec_show_menu);
	gtk_box_pack_start(GTK_BOX (orxonox_gui_exec_vbox), show_menu_button, TRUE, TRUE, 0);
	

	quit_button = gtk_button_new_with_label ("quit");
	g_signal_connect(GTK_BUTTON(quit_button), "clicked", G_CALLBACK(gtk_main_quit), NULL);
	gtk_box_pack_start(GTK_BOX (orxonox_gui_exec_vbox), quit_button, FALSE, FALSE, 5);


	flags_frame = gtk_frame_new("Orxonox's starting Flags");
	{
	  exec_flags_label = gtk_label_new("test");
	  exec_orxonox_settings = orxonox_settings;
	  orxonox_flags_update();
	  gtk_container_add (GTK_CONTAINER(flags_frame), exec_flags_label);

	}
	gtk_box_pack_start(GTK_BOX (orxonox_gui_exec_vbox), flags_frame, FALSE, FALSE, 5);
    }
    gtk_container_add(GTK_CONTAINER(frame), orxonox_gui_exec_vbox);
  }

  return frame;

}


char * orxonox_flags_text (struct settings *orxonox_settings, char *exec_flags_text)
{
  char temp [50];
  bzero(exec_flags_text, 1);
  strcat(exec_flags_text, "orxonox ");

  if(!orxonox_settings->video_fullscreen)
    strcat(exec_flags_text, "--windowed ");
  if(orxonox_settings->video_wireframe)
    strcat(exec_flags_text, "--wireframe ");
  
  if(!orxonox_settings->audio_enable_sound)
    strcat(exec_flags_text, "--disable_audio ");
  if(orxonox_settings->audio_music_volume != 80)
    {
      strcat(exec_flags_text, "--music_volume=");
      sprintf(temp, "%i ", (int) orxonox_settings->audio_music_volume);
      strcat(exec_flags_text, temp);
    }
  if(orxonox_settings->audio_effects_volume != 80)
    {
      strcat(exec_flags_text, "--effects_volume= ");
      sprintf(temp, "%i ", (int) orxonox_settings->audio_effects_volume);
      strcat(exec_flags_text, temp);
    }
  return (exec_flags_text);
}

void orxonox_flags_update (void)
{
  char exec_flags_text[1024];
  gtk_label_set_text (GTK_LABEL(exec_flags_label), orxonox_flags_text (exec_orxonox_settings, exec_flags_text));
  return;
}
